//---------------------------------------------------------------------------
#include "Square.h"

//---------------------------------------------------------------------------

//
// The function oneThruNine() returns a bitmap with bits 1-9 set.  It
// uses the static variables otn and firstTime.  Ideally, the vars
// would be static to the function, but hpgcc doesn't support that. I
// tried using a static variable and initializing it from a function,
// but that didn't work either.
static Bitmap otn;
static bool firstTime=true;

static Bitmap
oneThruNine()
{
    if (firstTime) {
	int i;
	for (i=1; i<10; ++i) {
	    otn += i;
	}
	firstTime = false;
    }
    return otn;
}

Square::Square()
{
    clear();
}

Square::Square(int v)
{
    setVal(v);
}

bool
Square::operator == (const Square &sq) const
{
    return (knownValue == sq.knownValue &&
            possibilities == sq.possibilities);
}

void
Square::clear()
{
    knownValue = 0;
    possibilities = oneThruNine();
}

// Set the knownValue member
void
Square::setKnownValue()
{
    if (possibilities.count() != 1) {
        knownValue = 0;
        return;
    }

    for (int i = 1; i < 10; ++i) {
        if (possibilities.check(i)) {
            knownValue = i;
            return;
        }
    }
}

// Is v a possible value?
bool
Square::isPossible(unsigned v)
{
    return possibilities.check(v);
}

// Set the square to the known value v
void
Square::setVal(int v)
{
    if (v < 1 || v > 9) return;
    possibilities.clear();
    possibilities += v;
    knownValue = v;
}

// Build a bitmap one through 9

