//---------------------------------------------------------------------------
#ifndef SquareH
#define SquareH
#include "bitmap.h"
//---------------------------------------------------------------------------
class Square {
public:
    Square();
    Square(int knownValue);

    bool operator == (const Square &sq) const;

    // Default copy constructor and assignment operator are okay.
    // Square(const Square &);
    // Square &operator=(const Square &);

    bool isPossible(unsigned val);      // is val a possible value
    void setVal(int knownValue);        // Set square to the knownValue.
    void clear();                       // clear value and mark all vals possible
    void setKnownValue();               // if only 1 val is possible then set it.

    int knownValue;                     // if non-zero, then this is the one
                                        // value that's possible here.

    Bitmap possibilities;               // bitmap of possibilities
    Bitmap flags;                       // miscellaneous flags
};

#endif
